
// Gives us access to all functions in the 'system' namespace
using System;

class HelloCSharp {

	// The method 'MAIN' is the entry point into an executable program
	// The method is 'static' because it refers to the class,
	// not any instances of the class.
	public static void Main(){
	
			// Write 'hello world' to the screen, in keeping with the
			// programming ritual
			Console.Write("Hello World\n");
	
			// Create some initialised value-types:
			int an_int = -2147483648;
			int an_int2 = 2147483647;
			uint unsigned_int = 4294967295;
			sbyte a_byte = -128;
			sbyte a_byte2 = 127;
			byte unsigned_byte = 255;
			short a_short = -32768;
			short a_short2 = 32767;
			ushort unsigned_short = 65535;
			long a_long = -9223372036854775808;
			long a_long2 = 9223372036854775807;
			ulong unsigned_long = 18446744073709551615;
			char a_char = 'A';      			
			float a_float = 1.5F;
			double a_double = 5.0D;
			decimal a_decimal = 1.9M;
			
			// display value of a value-type
			Console.Write("a_char contains {0}\n", a_char);

			// Now create some reference types
			object an_object; // a reference-value that doesn't
							  // point to anything yet	
							  				
			// create a new string in value-type style				  											
			string a_string = "A STRING!!!!!!";
			
			// now we can ask the unassigned reference 'an_object'
			// to point to the same place as a_string:
			an_object = a_string;
			
			// Call ToString() on the object that is pointed
			// to by an_object
			Console.Write("an_object now points to {0}\n", an_object.ToString());
									
			// As with references that point to Strings, references who point
			// to values or value-types have their content converted to a string
			// when ToString() is called (rather than displaying a class name).  
			// This next line causes 'Boxing' to go on behind the
			// scenes
			Console.Write("6.ToString() returns: {0}\n", 6.ToString());
			 
	}
}


	
